> For the complete documentation index, see [llms.txt](https://docs.alkemi.network/earn-contracts/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.alkemi.network/earn-contracts/docs/chainlink.md).

# ChainLink.sol

View Source: [contracts/ChainLink.sol](https://app.gitbook.com/s/-MQ0mmOovvt0G2zyJIgA/contracts/ChainLink.sol)

### Contract Members

**Constants & Variables**

```javascript
//internal members
mapping(address => contract AggregatorV3Interface) internal priceContractMapping;
uint256 internal constant expScale;
uint8 internal constant eighteen;

//public members
address public admin;
bool public paused;
address public wethAddressVerified;
address public wethAddressPublic;
contract AggregatorV3Interface public USDETHPriceFeed;
```

**Events**

```javascript
event assetAdded(address indexed assetAddress, address indexed priceFeedContract);
event assetRemoved(address indexed assetAddress);
event adminChanged(address indexed oldAdmin, address indexed newAdmin);
event verifiedWethAddressSet(address indexed wethAddressVerified);
event publicWethAddressSet(address indexed wethAddressPublic);
event contractPausedOrUnpaused(bool  currentStatus);
```

### Modifiers

* onlyAdmin

#### onlyAdmin

```javascript
modifier onlyAdmin() internal
```

**Arguments**

| Name | Type | Description |
| ---- | ---- | ----------- |

### Functions

* addAsset(address assetAddress, address priceFeedContract)
* removeAsset(address assetAddress)
* changeAdmin(address newAdmin)
* setWethAddressVerified(address \_wethAddressVerified)
* setWethAddressPublic(address \_wethAddressPublic)
* togglePause()
* getAssetPrice(address asset)
* ()

#### addAsset

```javascript
function addAsset(address assetAddress, address priceFeedContract) public nonpayable onlyAdmin
```

**Arguments**

| Name              | Type    | Description |
| ----------------- | ------- | ----------- |
| assetAddress      | address |             |
| priceFeedContract | address |             |

#### removeAsset

```javascript
function removeAsset(address assetAddress) public nonpayable onlyAdmin
```

**Arguments**

| Name         | Type    | Description |
| ------------ | ------- | ----------- |
| assetAddress | address |             |

#### changeAdmin

```javascript
function changeAdmin(address newAdmin) public nonpayable onlyAdmin
```

**Arguments**

| Name     | Type    | Description |
| -------- | ------- | ----------- |
| newAdmin | address |             |

#### setWethAddressVerified

```javascript
function setWethAddressVerified(address _wethAddressVerified) public nonpayable onlyAdmin
```

**Arguments**

| Name                  | Type    | Description |
| --------------------- | ------- | ----------- |
| \_wethAddressVerified | address |             |

#### setWethAddressPublic

```javascript
function setWethAddressPublic(address _wethAddressPublic) public nonpayable onlyAdmin
```

**Arguments**

| Name                | Type    | Description |
| ------------------- | ------- | ----------- |
| \_wethAddressPublic | address |             |

#### togglePause

```javascript
function togglePause() public nonpayable onlyAdmin
```

**Arguments**

| Name | Type | Description |
| ---- | ---- | ----------- |

#### getAssetPrice

```javascript
function getAssetPrice(address asset) public view
returns(uint256, uint8)
```

**Arguments**

| Name  | Type    | Description |
| ----- | ------- | ----------- |
| asset | address |             |

####

```javascript
function () public payable
```

**Arguments**

| Name | Type | Description |
| ---- | ---- | ----------- |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.alkemi.network/earn-contracts/docs/chainlink.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
